PACKAGE fft IS

	PROCEDURE fft		( VARIABLE XXr, XXi : inout Vecteur_N  );
	PROCEDURE fft_inverse	( VARIABLE XXr, XXi : inout Vecteur_N  );

	PROCEDURE reverse	( VARIABLE INr,  INi  : in Vecteur_N;
				  VARIABLE OUTr, OUTi : out Vecteur_N  );

END fft;

PACKAGE BODY fft IS

	CONSTANT N : INTEGER := 32;	-- taille de la FFT

	TYPE Vecteur_N   IS ARRAY (0 TO N - 1) OF INTEGER;

	----------------------------------------------------------------------------
	--	PROCEDURE DE FFT BASE 2 DIF SUR UN VECTEUR DE N ECHANTILLONS      --
	-- 		L'ENTREE EST REELLE , LA SORTIE COMPLEXE		  --
	----------------------------------------------------------------------------
	PROCEDURE fft(	VARIABLE XXr, XXi : inout Vecteur_N  ) IS

		VARIABLE Wr, Wi : Vecteur_N;
		VARIABLE tr, ti : INTEGER;
		VARIABLE C, S   : INTEGER;

		VARIABLE NA,NE : CONTROL;
		VARIABLE N1,N2 : CONTROL;
		VARIABLE ii,jj,ll : CONTROL;

	BEGIN

	N2 := N;
	while N2 > 0 loop

		N1 := N2;		
		N2 := N2 / 2;
		NE := N / N1;
		NA := 0;

		for jj in 0 to N2 - 1 loop
			C := Wr(NA) ;
			S := Wi(NA) ;
			NA := NA + NE;
			ii := jj;
			while  ii < N  loop

				ll := ii + N2;

				if N1 = N then
					tr := XXr(ii) - XXr(ll);
	
					XXr(ii) := XXr(ii) + XXr(ll);
					XXi(ii) := 0;
	
					XXr(ll) := C * tr;
					XXi(ll) := S * tr;
				else
					tr := XXr(ii) - XXr(ll);
					ti := XXi(ii) - XXi(ll);
	
					XXr(ii) := XXr(ii) + XXr(ll);
					XXi(ii) := XXi(ii) - XXi(ll);
	
					XXr(ll) := C * tr + S * ti;
					XXi(ll) := C * ti - S * tr;
				end if;
				ii := ii + N1;
			end loop;
		end loop;
	end loop;

	END fft;


	---------------------------------------------------------------------------------
	--	PROCEDURE DE FFT INVERSE BASE 2 DIF SUR UN VECTEUR DE N ECHANTILLONS   --
	-- 		L'ENTREE EST COMPLEXE , LA SORTIE REELLE		       --
	---------------------------------------------------------------------------------
	PROCEDURE fft_inverse(	VARIABLE XXr, XXi : inout Vecteur_N  ) IS


		VARIABLE Wr, Wi : Vecteur_N;
		VARIABLE tr, ti : INTEGER;
		VARIABLE C, S   : INTEGER;

		VARIABLE NA,NE : CONTROL;
		VARIABLE N1,N2 : CONTROL;
		VARIABLE ii,jj,ll : CONTROL;

	BEGIN

	N2 := N;
	while N2 > 0 loop

		N1 := N2;		
		N2 := N2 / 2;
		NE := N / N1;
		NA := 0;

		for jj in 0 to N2 - 1 loop

			C := Wr(NA) ;
			S := Wi(NA) ;
			NA := NA + NE;
			ii := jj;

			while  ii < N  loop
				ll := ii + N2;
				if N2 = 0 then
					tr := XXr(ii) - XXr(ll);
					ti := XXi(ii) - XXi(ll);
	
					XXr(ii) := XXr(ii) + XXr(ll);
	
					XXr(ll) := C * tr + S * ti;
				else
					tr := XXr(ii) - XXr(ll);
					ti := XXi(ii) - XXi(ll);
	
					XXr(ii) := XXr(ii) + XXr(ll);
					XXi(ii) := XXi(ii) - XXi(ll);
	
					XXr(ll) := C * tr + S * ti;
					XXi(ll) := C * ti - S * tr;
				end if;
				ii := ii + N1;
			end loop;
		end loop;
	end loop;

	END fft_inverse;

	----------------------------------------------------------------------
	--	PROCEDURE DE BIT REVERSE SUR UN VECTEUR DE N ECHANTILLONS   --
	----------------------------------------------------------------------
	PROCEDURE reverse(	VARIABLE INr,  INi  : in Vecteur_N;
				VARIABLE OUTr, OUTi : out Vecteur_N  ) IS

		VARIABLE i,j,k : CONTROL;

	BEGIN

		j := 0;
		for i in 0 to N-2 loop
			if j > i then
				OUTr(j) := INr(i);  
				OUTr(i) := INr(j);
				OUTi(j) := INi(i);
				OUTi(i) := INi(j);
			elsif j = i then
				OUTr(i) := INr(i);  
				OUTi(i) := INi(i);  
			end if;

			k := N / 2;
			while k <= j loop
				j := j - k;
				k := k / 2;
			end loop;

			j := j + k;
		end loop;
		OUTr(N-1) := INr(N-1);  
		OUTi(N-1) := INi(N-1);  

	END  reverse;


END fft;
