--------------------------------------------------------------------------
-- GAUT V3 LASTI-ENSSAT-UNIVERSITE DE RENNES 1 et LESTER-UBS fft.src
-- Mise a plat du fichier fft.src
-- Thu Apr 30 18:41:07 MET DST 1998
--------------------------------------------------------------------------
package fft is


end fft ;
package body fft is

		constant n : integer := 32 ;
--  taille de la fft
	type vecteur_n is array(0 to n - 1) of integer;
-- --------------------------------------------------------------------------
-- 	procedure de fft base 2 dif sur un vecteur de n echantillons      --
--  		l'entree est reelle , la sortie complexe		  --
-- --------------------------------------------------------------------------
-- -------------------------------------------------------------------------------
-- 	procedure de fft inverse base 2 dif sur un vecteur de n echantillons   --
--  		l'entree est complexe , la sortie reelle		       --
-- -------------------------------------------------------------------------------
-- --------------------------------------------------------------------
-- 	procedure de bit reverse sur un vecteur de n echantillons   --
-- --------------------------------------------------------------------

end fft ;
use fft ;
use types_fft ;

entity fft is

		port ( xr,xi :  in  vecteur_n ;yr,yi: out vecteur_n );

end fft ;

architecture arch_fft of fft is

--  fft 1024 points a 16 khz
		constant te : integer := 125000 ;
		constant nn : integer := 1024/n ;
		constant latence : integer := te ;
	begin

		process

		----------------------------------
		-- VARIABLES LOCALES AUX PROCEDURES
		-- procedure fft
		variable fft_wr,fft_wi : vecteur_n ;
		variable fft_tr,fft_ti : integer ;
		variable fft_c,fft_s : integer ;

		-- procedure fft_inverse
		variable fft_inverse_wr,fft_inverse_wi : vecteur_n ;
		variable fft_inverse_tr,fft_inverse_ti : integer ;
		variable fft_inverse_c,fft_inverse_s : integer ;

		-- procedure reverse

		----------------------------------

		variable xxr,xxi : vecteur_n ;
		begin

			 xxr(0) := xr(0) ;
			 xxi(0) := xi(0) ;
			 xxr(1) := xr(1) ;
			 xxi(1) := xi(1) ;
			 xxr(2) := xr(2) ;
			 xxi(2) := xi(2) ;
			 xxr(3) := xr(3) ;
			 xxi(3) := xi(3) ;
			 xxr(4) := xr(4) ;
			 xxi(4) := xi(4) ;
			 xxr(5) := xr(5) ;
			 xxi(5) := xi(5) ;
			 xxr(6) := xr(6) ;
			 xxi(6) := xi(6) ;
			 xxr(7) := xr(7) ;
			 xxi(7) := xi(7) ;
			 xxr(8) := xr(8) ;
			 xxi(8) := xi(8) ;
			 xxr(9) := xr(9) ;
			 xxi(9) := xi(9) ;
			 xxr(10) := xr(10) ;
			 xxi(10) := xi(10) ;
			 xxr(11) := xr(11) ;
			 xxi(11) := xi(11) ;
			 xxr(12) := xr(12) ;
			 xxi(12) := xi(12) ;
			 xxr(13) := xr(13) ;
			 xxi(13) := xi(13) ;
			 xxr(14) := xr(14) ;
			 xxi(14) := xi(14) ;
			 xxr(15) := xr(15) ;
			 xxi(15) := xi(15) ;
			 xxr(16) := xr(16) ;
			 xxi(16) := xi(16) ;
			 xxr(17) := xr(17) ;
			 xxi(17) := xi(17) ;
			 xxr(18) := xr(18) ;
			 xxi(18) := xi(18) ;
			 xxr(19) := xr(19) ;
			 xxi(19) := xi(19) ;
			 xxr(20) := xr(20) ;
			 xxi(20) := xi(20) ;
			 xxr(21) := xr(21) ;
			 xxi(21) := xi(21) ;
			 xxr(22) := xr(22) ;
			 xxi(22) := xi(22) ;
			 xxr(23) := xr(23) ;
			 xxi(23) := xi(23) ;
			 xxr(24) := xr(24) ;
			 xxi(24) := xi(24) ;
			 xxr(25) := xr(25) ;
			 xxi(25) := xi(25) ;
			 xxr(26) := xr(26) ;
			 xxi(26) := xi(26) ;
			 xxr(27) := xr(27) ;
			 xxi(27) := xi(27) ;
			 xxr(28) := xr(28) ;
			 xxi(28) := xi(28) ;
			 xxr(29) := xr(29) ;
			 xxi(29) := xi(29) ;
			 xxr(30) := xr(30) ;
			 xxi(30) := xi(30) ;
			 xxr(31) := xr(31) ;
			 xxi(31) := xi(31) ;

			-- DEBUT MISE A PLAT PROCEDURE fft
			 fft_c := wr(0) ;
			 fft_s := wi(0) ;
			 fft_tr := xxr(0) - xxr(16) ;
			 xxr(0) := xxr(0) + xxr(16) ;
			 xxi(0) := 0 ;
			 xxr(16) := fft_c * fft_tr ;
			 xxi(16) := fft_s * fft_tr ;
			 fft_c := wr(1) ;
			 fft_s := wi(1) ;
			 fft_tr := xxr(1) - xxr(17) ;
			 xxr(1) := xxr(1) + xxr(17) ;
			 xxi(1) := 0 ;
			 xxr(17) := fft_c * fft_tr ;
			 xxi(17) := fft_s * fft_tr ;
			 fft_c := wr(2) ;
			 fft_s := wi(2) ;
			 fft_tr := xxr(2) - xxr(18) ;
			 xxr(2) := xxr(2) + xxr(18) ;
			 xxi(2) := 0 ;
			 xxr(18) := fft_c * fft_tr ;
			 xxi(18) := fft_s * fft_tr ;
			 fft_c := wr(3) ;
			 fft_s := wi(3) ;
			 fft_tr := xxr(3) - xxr(19) ;
			 xxr(3) := xxr(3) + xxr(19) ;
			 xxi(3) := 0 ;
			 xxr(19) := fft_c * fft_tr ;
			 xxi(19) := fft_s * fft_tr ;
			 fft_c := wr(4) ;
			 fft_s := wi(4) ;
			 fft_tr := xxr(4) - xxr(20) ;
			 xxr(4) := xxr(4) + xxr(20) ;
			 xxi(4) := 0 ;
			 xxr(20) := fft_c * fft_tr ;
			 xxi(20) := fft_s * fft_tr ;
			 fft_c := wr(5) ;
			 fft_s := wi(5) ;
			 fft_tr := xxr(5) - xxr(21) ;
			 xxr(5) := xxr(5) + xxr(21) ;
			 xxi(5) := 0 ;
			 xxr(21) := fft_c * fft_tr ;
			 xxi(21) := fft_s * fft_tr ;
			 fft_c := wr(6) ;
			 fft_s := wi(6) ;
			 fft_tr := xxr(6) - xxr(22) ;
			 xxr(6) := xxr(6) + xxr(22) ;
			 xxi(6) := 0 ;
			 xxr(22) := fft_c * fft_tr ;
			 xxi(22) := fft_s * fft_tr ;
			 fft_c := wr(7) ;
			 fft_s := wi(7) ;
			 fft_tr := xxr(7) - xxr(23) ;
			 xxr(7) := xxr(7) + xxr(23) ;
			 xxi(7) := 0 ;
			 xxr(23) := fft_c * fft_tr ;
			 xxi(23) := fft_s * fft_tr ;
			 fft_c := wr(8) ;
			 fft_s := wi(8) ;
			 fft_tr := xxr(8) - xxr(24) ;
			 xxr(8) := xxr(8) + xxr(24) ;
			 xxi(8) := 0 ;
			 xxr(24) := fft_c * fft_tr ;
			 xxi(24) := fft_s * fft_tr ;
			 fft_c := wr(9) ;
			 fft_s := wi(9) ;
			 fft_tr := xxr(9) - xxr(25) ;
			 xxr(9) := xxr(9) + xxr(25) ;
			 xxi(9) := 0 ;
			 xxr(25) := fft_c * fft_tr ;
			 xxi(25) := fft_s * fft_tr ;
			 fft_c := wr(10) ;
			 fft_s := wi(10) ;
			 fft_tr := xxr(10) - xxr(26) ;
			 xxr(10) := xxr(10) + xxr(26) ;
			 xxi(10) := 0 ;
			 xxr(26) := fft_c * fft_tr ;
			 xxi(26) := fft_s * fft_tr ;
			 fft_c := wr(11) ;
			 fft_s := wi(11) ;
			 fft_tr := xxr(11) - xxr(27) ;
			 xxr(11) := xxr(11) + xxr(27) ;
			 xxi(11) := 0 ;
			 xxr(27) := fft_c * fft_tr ;
			 xxi(27) := fft_s * fft_tr ;
			 fft_c := wr(12) ;
			 fft_s := wi(12) ;
			 fft_tr := xxr(12) - xxr(28) ;
			 xxr(12) := xxr(12) + xxr(28) ;
			 xxi(12) := 0 ;
			 xxr(28) := fft_c * fft_tr ;
			 xxi(28) := fft_s * fft_tr ;
			 fft_c := wr(13) ;
			 fft_s := wi(13) ;
			 fft_tr := xxr(13) - xxr(29) ;
			 xxr(13) := xxr(13) + xxr(29) ;
			 xxi(13) := 0 ;
			 xxr(29) := fft_c * fft_tr ;
			 xxi(29) := fft_s * fft_tr ;
			 fft_c := wr(14) ;
			 fft_s := wi(14) ;
			 fft_tr := xxr(14) - xxr(30) ;
			 xxr(14) := xxr(14) + xxr(30) ;
			 xxi(14) := 0 ;
			 xxr(30) := fft_c * fft_tr ;
			 xxi(30) := fft_s * fft_tr ;
			 fft_c := wr(15) ;
			 fft_s := wi(15) ;
			 fft_tr := xxr(15) - xxr(31) ;
			 xxr(15) := xxr(15) + xxr(31) ;
			 xxi(15) := 0 ;
			 xxr(31) := fft_c * fft_tr ;
			 xxi(31) := fft_s * fft_tr ;
			 fft_c := wr(0) ;
			 fft_s := wi(0) ;
			 fft_tr := xxr(0) - xxr(8) ;
			 fft_ti := xxi(0) - xxi(8) ;
			 xxr(0) := xxr(0) + xxr(8) ;
			 xxi(0) := xxi(0) - xxi(8) ;
			 xxr(8) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(8) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(16) - xxr(24) ;
			 fft_ti := xxi(16) - xxi(24) ;
			 xxr(16) := xxr(16) + xxr(24) ;
			 xxi(16) := xxi(16) - xxi(24) ;
			 xxr(24) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(24) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(2) ;
			 fft_s := wi(2) ;
			 fft_tr := xxr(1) - xxr(9) ;
			 fft_ti := xxi(1) - xxi(9) ;
			 xxr(1) := xxr(1) + xxr(9) ;
			 xxi(1) := xxi(1) - xxi(9) ;
			 xxr(9) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(9) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(17) - xxr(25) ;
			 fft_ti := xxi(17) - xxi(25) ;
			 xxr(17) := xxr(17) + xxr(25) ;
			 xxi(17) := xxi(17) - xxi(25) ;
			 xxr(25) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(25) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(4) ;
			 fft_s := wi(4) ;
			 fft_tr := xxr(2) - xxr(10) ;
			 fft_ti := xxi(2) - xxi(10) ;
			 xxr(2) := xxr(2) + xxr(10) ;
			 xxi(2) := xxi(2) - xxi(10) ;
			 xxr(10) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(10) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(18) - xxr(26) ;
			 fft_ti := xxi(18) - xxi(26) ;
			 xxr(18) := xxr(18) + xxr(26) ;
			 xxi(18) := xxi(18) - xxi(26) ;
			 xxr(26) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(26) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(6) ;
			 fft_s := wi(6) ;
			 fft_tr := xxr(3) - xxr(11) ;
			 fft_ti := xxi(3) - xxi(11) ;
			 xxr(3) := xxr(3) + xxr(11) ;
			 xxi(3) := xxi(3) - xxi(11) ;
			 xxr(11) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(11) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(19) - xxr(27) ;
			 fft_ti := xxi(19) - xxi(27) ;
			 xxr(19) := xxr(19) + xxr(27) ;
			 xxi(19) := xxi(19) - xxi(27) ;
			 xxr(27) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(27) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(8) ;
			 fft_s := wi(8) ;
			 fft_tr := xxr(4) - xxr(12) ;
			 fft_ti := xxi(4) - xxi(12) ;
			 xxr(4) := xxr(4) + xxr(12) ;
			 xxi(4) := xxi(4) - xxi(12) ;
			 xxr(12) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(12) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(20) - xxr(28) ;
			 fft_ti := xxi(20) - xxi(28) ;
			 xxr(20) := xxr(20) + xxr(28) ;
			 xxi(20) := xxi(20) - xxi(28) ;
			 xxr(28) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(28) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(10) ;
			 fft_s := wi(10) ;
			 fft_tr := xxr(5) - xxr(13) ;
			 fft_ti := xxi(5) - xxi(13) ;
			 xxr(5) := xxr(5) + xxr(13) ;
			 xxi(5) := xxi(5) - xxi(13) ;
			 xxr(13) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(13) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(21) - xxr(29) ;
			 fft_ti := xxi(21) - xxi(29) ;
			 xxr(21) := xxr(21) + xxr(29) ;
			 xxi(21) := xxi(21) - xxi(29) ;
			 xxr(29) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(29) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(12) ;
			 fft_s := wi(12) ;
			 fft_tr := xxr(6) - xxr(14) ;
			 fft_ti := xxi(6) - xxi(14) ;
			 xxr(6) := xxr(6) + xxr(14) ;
			 xxi(6) := xxi(6) - xxi(14) ;
			 xxr(14) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(14) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(22) - xxr(30) ;
			 fft_ti := xxi(22) - xxi(30) ;
			 xxr(22) := xxr(22) + xxr(30) ;
			 xxi(22) := xxi(22) - xxi(30) ;
			 xxr(30) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(30) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(14) ;
			 fft_s := wi(14) ;
			 fft_tr := xxr(7) - xxr(15) ;
			 fft_ti := xxi(7) - xxi(15) ;
			 xxr(7) := xxr(7) + xxr(15) ;
			 xxi(7) := xxi(7) - xxi(15) ;
			 xxr(15) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(15) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(23) - xxr(31) ;
			 fft_ti := xxi(23) - xxi(31) ;
			 xxr(23) := xxr(23) + xxr(31) ;
			 xxi(23) := xxi(23) - xxi(31) ;
			 xxr(31) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(31) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(0) ;
			 fft_s := wi(0) ;
			 fft_tr := xxr(0) - xxr(4) ;
			 fft_ti := xxi(0) - xxi(4) ;
			 xxr(0) := xxr(0) + xxr(4) ;
			 xxi(0) := xxi(0) - xxi(4) ;
			 xxr(4) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(4) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(8) - xxr(12) ;
			 fft_ti := xxi(8) - xxi(12) ;
			 xxr(8) := xxr(8) + xxr(12) ;
			 xxi(8) := xxi(8) - xxi(12) ;
			 xxr(12) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(12) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(16) - xxr(20) ;
			 fft_ti := xxi(16) - xxi(20) ;
			 xxr(16) := xxr(16) + xxr(20) ;
			 xxi(16) := xxi(16) - xxi(20) ;
			 xxr(20) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(20) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(24) - xxr(28) ;
			 fft_ti := xxi(24) - xxi(28) ;
			 xxr(24) := xxr(24) + xxr(28) ;
			 xxi(24) := xxi(24) - xxi(28) ;
			 xxr(28) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(28) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(4) ;
			 fft_s := wi(4) ;
			 fft_tr := xxr(1) - xxr(5) ;
			 fft_ti := xxi(1) - xxi(5) ;
			 xxr(1) := xxr(1) + xxr(5) ;
			 xxi(1) := xxi(1) - xxi(5) ;
			 xxr(5) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(5) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(9) - xxr(13) ;
			 fft_ti := xxi(9) - xxi(13) ;
			 xxr(9) := xxr(9) + xxr(13) ;
			 xxi(9) := xxi(9) - xxi(13) ;
			 xxr(13) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(13) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(17) - xxr(21) ;
			 fft_ti := xxi(17) - xxi(21) ;
			 xxr(17) := xxr(17) + xxr(21) ;
			 xxi(17) := xxi(17) - xxi(21) ;
			 xxr(21) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(21) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(25) - xxr(29) ;
			 fft_ti := xxi(25) - xxi(29) ;
			 xxr(25) := xxr(25) + xxr(29) ;
			 xxi(25) := xxi(25) - xxi(29) ;
			 xxr(29) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(29) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(8) ;
			 fft_s := wi(8) ;
			 fft_tr := xxr(2) - xxr(6) ;
			 fft_ti := xxi(2) - xxi(6) ;
			 xxr(2) := xxr(2) + xxr(6) ;
			 xxi(2) := xxi(2) - xxi(6) ;
			 xxr(6) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(6) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(10) - xxr(14) ;
			 fft_ti := xxi(10) - xxi(14) ;
			 xxr(10) := xxr(10) + xxr(14) ;
			 xxi(10) := xxi(10) - xxi(14) ;
			 xxr(14) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(14) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(18) - xxr(22) ;
			 fft_ti := xxi(18) - xxi(22) ;
			 xxr(18) := xxr(18) + xxr(22) ;
			 xxi(18) := xxi(18) - xxi(22) ;
			 xxr(22) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(22) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(26) - xxr(30) ;
			 fft_ti := xxi(26) - xxi(30) ;
			 xxr(26) := xxr(26) + xxr(30) ;
			 xxi(26) := xxi(26) - xxi(30) ;
			 xxr(30) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(30) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(12) ;
			 fft_s := wi(12) ;
			 fft_tr := xxr(3) - xxr(7) ;
			 fft_ti := xxi(3) - xxi(7) ;
			 xxr(3) := xxr(3) + xxr(7) ;
			 xxi(3) := xxi(3) - xxi(7) ;
			 xxr(7) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(7) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(11) - xxr(15) ;
			 fft_ti := xxi(11) - xxi(15) ;
			 xxr(11) := xxr(11) + xxr(15) ;
			 xxi(11) := xxi(11) - xxi(15) ;
			 xxr(15) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(15) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(19) - xxr(23) ;
			 fft_ti := xxi(19) - xxi(23) ;
			 xxr(19) := xxr(19) + xxr(23) ;
			 xxi(19) := xxi(19) - xxi(23) ;
			 xxr(23) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(23) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(27) - xxr(31) ;
			 fft_ti := xxi(27) - xxi(31) ;
			 xxr(27) := xxr(27) + xxr(31) ;
			 xxi(27) := xxi(27) - xxi(31) ;
			 xxr(31) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(31) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(0) ;
			 fft_s := wi(0) ;
			 fft_tr := xxr(0) - xxr(2) ;
			 fft_ti := xxi(0) - xxi(2) ;
			 xxr(0) := xxr(0) + xxr(2) ;
			 xxi(0) := xxi(0) - xxi(2) ;
			 xxr(2) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(2) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(4) - xxr(6) ;
			 fft_ti := xxi(4) - xxi(6) ;
			 xxr(4) := xxr(4) + xxr(6) ;
			 xxi(4) := xxi(4) - xxi(6) ;
			 xxr(6) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(6) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(8) - xxr(10) ;
			 fft_ti := xxi(8) - xxi(10) ;
			 xxr(8) := xxr(8) + xxr(10) ;
			 xxi(8) := xxi(8) - xxi(10) ;
			 xxr(10) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(10) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(12) - xxr(14) ;
			 fft_ti := xxi(12) - xxi(14) ;
			 xxr(12) := xxr(12) + xxr(14) ;
			 xxi(12) := xxi(12) - xxi(14) ;
			 xxr(14) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(14) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(16) - xxr(18) ;
			 fft_ti := xxi(16) - xxi(18) ;
			 xxr(16) := xxr(16) + xxr(18) ;
			 xxi(16) := xxi(16) - xxi(18) ;
			 xxr(18) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(18) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(20) - xxr(22) ;
			 fft_ti := xxi(20) - xxi(22) ;
			 xxr(20) := xxr(20) + xxr(22) ;
			 xxi(20) := xxi(20) - xxi(22) ;
			 xxr(22) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(22) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(24) - xxr(26) ;
			 fft_ti := xxi(24) - xxi(26) ;
			 xxr(24) := xxr(24) + xxr(26) ;
			 xxi(24) := xxi(24) - xxi(26) ;
			 xxr(26) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(26) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(28) - xxr(30) ;
			 fft_ti := xxi(28) - xxi(30) ;
			 xxr(28) := xxr(28) + xxr(30) ;
			 xxi(28) := xxi(28) - xxi(30) ;
			 xxr(30) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(30) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(8) ;
			 fft_s := wi(8) ;
			 fft_tr := xxr(1) - xxr(3) ;
			 fft_ti := xxi(1) - xxi(3) ;
			 xxr(1) := xxr(1) + xxr(3) ;
			 xxi(1) := xxi(1) - xxi(3) ;
			 xxr(3) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(3) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(5) - xxr(7) ;
			 fft_ti := xxi(5) - xxi(7) ;
			 xxr(5) := xxr(5) + xxr(7) ;
			 xxi(5) := xxi(5) - xxi(7) ;
			 xxr(7) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(7) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(9) - xxr(11) ;
			 fft_ti := xxi(9) - xxi(11) ;
			 xxr(9) := xxr(9) + xxr(11) ;
			 xxi(9) := xxi(9) - xxi(11) ;
			 xxr(11) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(11) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(13) - xxr(15) ;
			 fft_ti := xxi(13) - xxi(15) ;
			 xxr(13) := xxr(13) + xxr(15) ;
			 xxi(13) := xxi(13) - xxi(15) ;
			 xxr(15) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(15) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(17) - xxr(19) ;
			 fft_ti := xxi(17) - xxi(19) ;
			 xxr(17) := xxr(17) + xxr(19) ;
			 xxi(17) := xxi(17) - xxi(19) ;
			 xxr(19) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(19) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(21) - xxr(23) ;
			 fft_ti := xxi(21) - xxi(23) ;
			 xxr(21) := xxr(21) + xxr(23) ;
			 xxi(21) := xxi(21) - xxi(23) ;
			 xxr(23) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(23) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(25) - xxr(27) ;
			 fft_ti := xxi(25) - xxi(27) ;
			 xxr(25) := xxr(25) + xxr(27) ;
			 xxi(25) := xxi(25) - xxi(27) ;
			 xxr(27) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(27) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(29) - xxr(31) ;
			 fft_ti := xxi(29) - xxi(31) ;
			 xxr(29) := xxr(29) + xxr(31) ;
			 xxi(29) := xxi(29) - xxi(31) ;
			 xxr(31) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(31) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_c := wr(0) ;
			 fft_s := wi(0) ;
			 fft_tr := xxr(0) - xxr(1) ;
			 fft_ti := xxi(0) - xxi(1) ;
			 xxr(0) := xxr(0) + xxr(1) ;
			 xxi(0) := xxi(0) - xxi(1) ;
			 xxr(1) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(1) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(2) - xxr(3) ;
			 fft_ti := xxi(2) - xxi(3) ;
			 xxr(2) := xxr(2) + xxr(3) ;
			 xxi(2) := xxi(2) - xxi(3) ;
			 xxr(3) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(3) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(4) - xxr(5) ;
			 fft_ti := xxi(4) - xxi(5) ;
			 xxr(4) := xxr(4) + xxr(5) ;
			 xxi(4) := xxi(4) - xxi(5) ;
			 xxr(5) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(5) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(6) - xxr(7) ;
			 fft_ti := xxi(6) - xxi(7) ;
			 xxr(6) := xxr(6) + xxr(7) ;
			 xxi(6) := xxi(6) - xxi(7) ;
			 xxr(7) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(7) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(8) - xxr(9) ;
			 fft_ti := xxi(8) - xxi(9) ;
			 xxr(8) := xxr(8) + xxr(9) ;
			 xxi(8) := xxi(8) - xxi(9) ;
			 xxr(9) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(9) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(10) - xxr(11) ;
			 fft_ti := xxi(10) - xxi(11) ;
			 xxr(10) := xxr(10) + xxr(11) ;
			 xxi(10) := xxi(10) - xxi(11) ;
			 xxr(11) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(11) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(12) - xxr(13) ;
			 fft_ti := xxi(12) - xxi(13) ;
			 xxr(12) := xxr(12) + xxr(13) ;
			 xxi(12) := xxi(12) - xxi(13) ;
			 xxr(13) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(13) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(14) - xxr(15) ;
			 fft_ti := xxi(14) - xxi(15) ;
			 xxr(14) := xxr(14) + xxr(15) ;
			 xxi(14) := xxi(14) - xxi(15) ;
			 xxr(15) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(15) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(16) - xxr(17) ;
			 fft_ti := xxi(16) - xxi(17) ;
			 xxr(16) := xxr(16) + xxr(17) ;
			 xxi(16) := xxi(16) - xxi(17) ;
			 xxr(17) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(17) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(18) - xxr(19) ;
			 fft_ti := xxi(18) - xxi(19) ;
			 xxr(18) := xxr(18) + xxr(19) ;
			 xxi(18) := xxi(18) - xxi(19) ;
			 xxr(19) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(19) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(20) - xxr(21) ;
			 fft_ti := xxi(20) - xxi(21) ;
			 xxr(20) := xxr(20) + xxr(21) ;
			 xxi(20) := xxi(20) - xxi(21) ;
			 xxr(21) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(21) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(22) - xxr(23) ;
			 fft_ti := xxi(22) - xxi(23) ;
			 xxr(22) := xxr(22) + xxr(23) ;
			 xxi(22) := xxi(22) - xxi(23) ;
			 xxr(23) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(23) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(24) - xxr(25) ;
			 fft_ti := xxi(24) - xxi(25) ;
			 xxr(24) := xxr(24) + xxr(25) ;
			 xxi(24) := xxi(24) - xxi(25) ;
			 xxr(25) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(25) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(26) - xxr(27) ;
			 fft_ti := xxi(26) - xxi(27) ;
			 xxr(26) := xxr(26) + xxr(27) ;
			 xxi(26) := xxi(26) - xxi(27) ;
			 xxr(27) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(27) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(28) - xxr(29) ;
			 fft_ti := xxi(28) - xxi(29) ;
			 xxr(28) := xxr(28) + xxr(29) ;
			 xxi(28) := xxi(28) - xxi(29) ;
			 xxr(29) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(29) := fft_c * fft_ti - fft_s * fft_tr ;
			 fft_tr := xxr(30) - xxr(31) ;
			 fft_ti := xxi(30) - xxi(31) ;
			 xxr(30) := xxr(30) + xxr(31) ;
			 xxi(30) := xxi(30) - xxi(31) ;
			 xxr(31) := fft_c * fft_tr + fft_s * fft_ti ;
			 xxi(31) := fft_c * fft_ti - fft_s * fft_tr ;

			-- FIN MISE A PLAT PROCEDURE fft

			 yr(0) <= xxr(0) ;
			 yi(0) <= xxi(0) ;
			 yr(1) <= xxr(1) ;
			 yi(1) <= xxi(1) ;
			 yr(2) <= xxr(2) ;
			 yi(2) <= xxi(2) ;
			 yr(3) <= xxr(3) ;
			 yi(3) <= xxi(3) ;
			 yr(4) <= xxr(4) ;
			 yi(4) <= xxi(4) ;
			 yr(5) <= xxr(5) ;
			 yi(5) <= xxi(5) ;
			 yr(6) <= xxr(6) ;
			 yi(6) <= xxi(6) ;
			 yr(7) <= xxr(7) ;
			 yi(7) <= xxi(7) ;
			 yr(8) <= xxr(8) ;
			 yi(8) <= xxi(8) ;
			 yr(9) <= xxr(9) ;
			 yi(9) <= xxi(9) ;
			 yr(10) <= xxr(10) ;
			 yi(10) <= xxi(10) ;
			 yr(11) <= xxr(11) ;
			 yi(11) <= xxi(11) ;
			 yr(12) <= xxr(12) ;
			 yi(12) <= xxi(12) ;
			 yr(13) <= xxr(13) ;
			 yi(13) <= xxi(13) ;
			 yr(14) <= xxr(14) ;
			 yi(14) <= xxi(14) ;
			 yr(15) <= xxr(15) ;
			 yi(15) <= xxi(15) ;
			 yr(16) <= xxr(16) ;
			 yi(16) <= xxi(16) ;
			 yr(17) <= xxr(17) ;
			 yi(17) <= xxi(17) ;
			 yr(18) <= xxr(18) ;
			 yi(18) <= xxi(18) ;
			 yr(19) <= xxr(19) ;
			 yi(19) <= xxi(19) ;
			 yr(20) <= xxr(20) ;
			 yi(20) <= xxi(20) ;
			 yr(21) <= xxr(21) ;
			 yi(21) <= xxi(21) ;
			 yr(22) <= xxr(22) ;
			 yi(22) <= xxi(22) ;
			 yr(23) <= xxr(23) ;
			 yi(23) <= xxi(23) ;
			 yr(24) <= xxr(24) ;
			 yi(24) <= xxi(24) ;
			 yr(25) <= xxr(25) ;
			 yi(25) <= xxi(25) ;
			 yr(26) <= xxr(26) ;
			 yi(26) <= xxi(26) ;
			 yr(27) <= xxr(27) ;
			 yi(27) <= xxi(27) ;
			 yr(28) <= xxr(28) ;
			 yi(28) <= xxi(28) ;
			 yr(29) <= xxr(29) ;
			 yi(29) <= xxi(29) ;
			 yr(30) <= xxr(30) ;
			 yi(30) <= xxi(30) ;
			 yr(31) <= xxr(31) ;
			 yi(31) <= xxi(31) ;

			wait for latence;

		end process;
end arch_fft;
