--------------------------------------------------------------------------
-- GAUT V3 LASTI-ENSSAT-UNIVERSITE DE RENNES 1 et LESTER-UBS lms.src
-- Mise a plat du fichier lms.src
-- Thu May 7 12:11:48 MET DST 1998
--------------------------------------------------------------------------
--  package des types 
package lms is

		constant n : integer := 16 ;
	type vecteur is array(0 to n - 1) of integer;

end lms ;
--  entite du lms

entity lms is

		generic ( latence : time := 6000 ns );
		port ( xn :  in  integer ;err: out integer;hh: out vecteur );

end lms ;

architecture comportementale of lms is

	begin

		process

		variable x : vecteur ;
		variable h : vecteur ;
		variable hr : vecteur := (381,1193,384,-2527,-3866,1438,13051,23067,23067,13051,1438,-3866,-2527,384,1193,381) ;
		variable tmp : integer := 0 ;
		variable yn,yr : integer ;
		variable adapt : integer ;
		variable deux_mu : integer := 2 ;
		begin

--  calcul du filtre adapte
--  calcul du filtre de reference
--  calcul de l'erreur
--  adaptation du filtre
			 x(0) := xn ;
			 tmp := 0 ;
			 tmp := tmp + x(0) * h(n - 0 - 1) ;
			 tmp := tmp + x(1) * h(n - 1 - 1) ;
			 tmp := tmp + x(2) * h(n - 2 - 1) ;
			 tmp := tmp + x(3) * h(n - 3 - 1) ;
			 tmp := tmp + x(4) * h(n - 4 - 1) ;
			 tmp := tmp + x(5) * h(n - 5 - 1) ;
			 tmp := tmp + x(6) * h(n - 6 - 1) ;
			 tmp := tmp + x(7) * h(n - 7 - 1) ;
			 tmp := tmp + x(8) * h(n - 8 - 1) ;
			 tmp := tmp + x(9) * h(n - 9 - 1) ;
			 tmp := tmp + x(10) * h(n - 10 - 1) ;
			 tmp := tmp + x(11) * h(n - 11 - 1) ;
			 tmp := tmp + x(12) * h(n - 12 - 1) ;
			 tmp := tmp + x(13) * h(n - 13 - 1) ;
			 tmp := tmp + x(14) * h(n - 14 - 1) ;
			 tmp := tmp + x(15) * h(n - 15 - 1) ;
			 yn := tmp ;
			 tmp := 0 ;
			 tmp := tmp + x(0) * hr(n - 0 - 1) ;
			 tmp := tmp + x(1) * hr(n - 1 - 1) ;
			 tmp := tmp + x(2) * hr(n - 2 - 1) ;
			 tmp := tmp + x(3) * hr(n - 3 - 1) ;
			 tmp := tmp + x(4) * hr(n - 4 - 1) ;
			 tmp := tmp + x(5) * hr(n - 5 - 1) ;
			 tmp := tmp + x(6) * hr(n - 6 - 1) ;
			 tmp := tmp + x(7) * hr(n - 7 - 1) ;
			 tmp := tmp + x(8) * hr(n - 8 - 1) ;
			 tmp := tmp + x(9) * hr(n - 9 - 1) ;
			 tmp := tmp + x(10) * hr(n - 10 - 1) ;
			 tmp := tmp + x(11) * hr(n - 11 - 1) ;
			 tmp := tmp + x(12) * hr(n - 12 - 1) ;
			 tmp := tmp + x(13) * hr(n - 13 - 1) ;
			 tmp := tmp + x(14) * hr(n - 14 - 1) ;
			 tmp := tmp + x(15) * hr(n - 15 - 1) ;
			 yr := tmp ;
			 tmp := yr - yn ;
			 err <= tmp ;
			 adapt := deux_mu * tmp ;
			 hh(0) <= h(0) ;
			 hh(1) <= h(1) ;
			 hh(2) <= h(2) ;
			 hh(3) <= h(3) ;
			 hh(4) <= h(4) ;
			 hh(5) <= h(5) ;
			 hh(6) <= h(6) ;
			 hh(7) <= h(7) ;
			 hh(8) <= h(8) ;
			 hh(9) <= h(9) ;
			 hh(10) <= h(10) ;
			 hh(11) <= h(11) ;
			 hh(12) <= h(12) ;
			 hh(13) <= h(13) ;
			 hh(14) <= h(14) ;
			 hh(15) <= h(15) ;
			 h(0) := h(0) + adapt * x(n - 0 - 1) ;
			 h(1) := h(1) + adapt * x(n - 1 - 1) ;
			 h(2) := h(2) + adapt * x(n - 2 - 1) ;
			 h(3) := h(3) + adapt * x(n - 3 - 1) ;
			 h(4) := h(4) + adapt * x(n - 4 - 1) ;
			 h(5) := h(5) + adapt * x(n - 5 - 1) ;
			 h(6) := h(6) + adapt * x(n - 6 - 1) ;
			 h(7) := h(7) + adapt * x(n - 7 - 1) ;
			 h(8) := h(8) + adapt * x(n - 8 - 1) ;
			 h(9) := h(9) + adapt * x(n - 9 - 1) ;
			 h(10) := h(10) + adapt * x(n - 10 - 1) ;
			 h(11) := h(11) + adapt * x(n - 11 - 1) ;
			 h(12) := h(12) + adapt * x(n - 12 - 1) ;
			 h(13) := h(13) + adapt * x(n - 13 - 1) ;
			 h(14) := h(14) + adapt * x(n - 14 - 1) ;
			 h(15) := h(15) + adapt * x(n - 15 - 1) ;
			 x(15) := x(15 - 1) ;
			 x(14) := x(14 - 1) ;
			 x(13) := x(13 - 1) ;
			 x(12) := x(12 - 1) ;
			 x(11) := x(11 - 1) ;
			 x(10) := x(10 - 1) ;
			 x(9) := x(9 - 1) ;
			 x(8) := x(8 - 1) ;
			 x(7) := x(7 - 1) ;
			 x(6) := x(6 - 1) ;
			 x(5) := x(5 - 1) ;
			 x(4) := x(4 - 1) ;
			 x(3) := x(3 - 1) ;
			 x(2) := x(2 - 1) ;
			 x(1) := xn ;

			wait for latence;

		end process;
end comportementale;
