// cmult.cc implementation file

#include "systemc.h"
#include "cmult.h"

void cmult_hs :: entry()
{
   sc_int<8> a, b, c, d;

   //Initialize and reset if reset asserts
   ready_for_data.write(false);
   output_data_ready.write(false);
   real_out.write(0);
   imag_out.write(0);
   wait(); //need clock to initialize before while loop

   while (true)
   {
     ready_for_data.write(true);
     output_data_ready.write(false);

     wait_until(new_data.delayed() == true);
     ready_for_data.write(false);

     // Read four data values from input port
     a = data_in.read();
     wait();
     b = data_in.read();
     wait();
     c = data_in.read();
     wait();
     d = data_in.read();
     wait();
     //Calculate and write output ports
     real_out.write(a * c - b * d);
     imag_out.write(a * d + b * c);
     output_data_ready.write(true);
     wait();
   }
}
