// cmult.h header file
SC_MODULE(cmult_hs) {
	// Declare ports
	sc_in<bool> reset;
	sc_in<bool> new_data;
	sc_in<sc_int<8> > data_in;
	sc_in_clk clk;
	sc_out<bool> ready_for_data;
	sc_out<bool> output_data_ready;
	sc_out<sc_int<16> > real_out;
	sc_out<sc_int<16> > imag_out;

	// Declare internal variables and signals

	// Declare processes in the module
	void entry();

	// Constructor
	SC_CTOR (cmult_hs) {
		// Register processes and
		// define active clock edge
		SC_CTHREAD(entry, clk.pos());

		// Watching for global reset
		watching(reset.delayed() == true);
	}
};
