//
//  Purpose  : Connecting between  Testbench (stimuls/display) and
//             inlining test module.
//
//             This is the top module.
///////////////////////////////////////////////////////////////

#include <systemc.h>
#include "stimulus.h"
#include "display.h"
#include "cmult.h"

int sc_main (int argc , char *argv[]) {
  sc_clock        clk("clk", 10, 0.5, 0.0);
  sc_signal<bool> reset;
  sc_signal<bool>        new_data;        
  sc_signal<sc_int<8> >   data_in;  	    
  sc_signal<bool>        ready_for_data;   
  sc_signal<bool>        output_data_ready;
  sc_signal<sc_int<16> > real_out;
  sc_signal<sc_int<16> > imag_out;

  stimulus stimulus1("stimulus_block");
     stimulus1.clk(clk);
     stimulus1.reset(reset);
     stimulus1.new_data(new_data);
     stimulus1.data_in(data_in);
     stimulus1.ready_for_data(ready_for_data);

  cmult_hs   cmult1    ( "process_block");
     cmult1.reset(reset);
     cmult1.new_data(new_data);
     cmult1.data_in(data_in);
     cmult1.clk(clk);
     cmult1.ready_for_data(ready_for_data);
     cmult1.output_data_ready(output_data_ready);
     cmult1.real_out(real_out);
     cmult1.imag_out(imag_out);

  display  display1 ( "display");
     display1.clk(clk);
     display1.output_data_ready(output_data_ready);
     display1.real_out(real_out);
     display1.imag_out(imag_out);

  sc_clock::start(-1);

  return 0;
}

// EOF
